﻿using System;
using System.IO;
using FlatBuffers;
using MyGame;

namespace ProtoOhDear
{
    class Program
    {
        static void Main(string[] args)
        {
            var fbb = new FlatBufferBuilder(1);
            Mesh.StartPositionsVector(fbb, 9);
            fbb.AddOffset(Vec3.CreateVec3(fbb, -1f, +2f, -3f));
            fbb.AddOffset(Vec3.CreateVec3(fbb, +4f, -5f, +6f));
            fbb.AddOffset(Vec3.CreateVec3(fbb, -7f, +8f, -9f));
            int positionsVector = fbb.EndVector();

            var indicesVector = Mesh.CreateIndicesVector(fbb, new int[] { 1, 2, 3 });

            int wm = Mesh.CreateMesh(fbb, positionsVector, indicesVector);
            Mesh.FinishMeshBuffer(fbb, wm);
            
            var readMesh = Mesh.GetRootAsMesh(fbb.DataBuffer);
            Vec3 scratch = new Vec3();

            for (int i = 0; i < readMesh.PositionsLength(); i++)
            {
                var v = readMesh.Positions(scratch, i);
                Console.WriteLine("{0},{1},{2}", v.X().ToString("F2"), v.Y().ToString("F2"), v.Z().ToString("F2"));
            }

            var indicesLength = readMesh.IndicesLength();
            for (int i = 0; i < indicesLength; i++)
            {
                Console.WriteLine(readMesh.Indices(i));
            }
        }
    }
}
